var g_ox_sdk_request_map = [];
  var g_ox_sdk_init_callback_func = null;

  function ox_sdk_init_set_callback_func(objFunc) {
  	g_ox_sdk_init_callback_func = objFunc;
  }
  /**
   * [ox_js_to_native js请求源生]
   * @param {[String]} [method] [验证方法]
   * @param {[object]} [params] [验证参数]
   * @param {[func]} [fnCallBack] [回调函数]
   * @return {[type]} [description]
   */
  function ox_js_to_native(objParams) {
  	if (typeof objParams != "object" || JSON.stringify(objParams) == "{}") {
  		return false;
  	}

  	if (objParams.method == "" || objParams.method == undefined) {
  		return false;
  	}

  	if (typeof objParams.params != "object" || objParams.params == undefined) {
  		return false;
  	}

  	if (typeof objParams.fnCallBack != "function") {
  		return false;
  	}

  	var osUserAgent = navigator.userAgent;
  	var strFunc = objParams.method;
  	var strPostData = objParams.params;
  	var strRequestId = getRand(18);
  	g_ox_sdk_request_map[strRequestId] = objParams.fnCallBack;
  	strPostData.request_id = strRequestId;
  	if (osUserAgent.indexOf('Android') > -1 || osUserAgent.indexOf('Adr') > -1) {
  		window.oxWeb.oxJsCallNative(strFunc, JSON.stringify(strPostData));
  	} else if (!!osUserAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
  		delete objParams["fnCallBack"];
  		window.webkit.messageHandlers.ox_js_to_native.postMessage(objParams);
  	} else {
  		return false;
  	}
  }

  /**
   *  关闭授权页
   */
  function ox_close_auth_page() {
  	var osUserAgent = navigator.userAgent;
  	if (osUserAgent.indexOf('Android') > -1 || osUserAgent.indexOf('Adr') > -1) {
  		window.oxWeb.finishAuthActivity();
  	} else if (!!osUserAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) {
  		var objParams = {};
  		objParams.method = "finishController";
  		window.webkit.messageHandlers.ox_js_to_native.postMessage(objParams);
  	} else {
  		return false;
  	}
  }

  /**
   * [ox_native_to_js 源生app通过该函数调用js中的函数]
   *  @param {String} [strResult] [调用结果]
   * @return {[type]} [description]
   */
  function ox_native_to_js(strResult) {
  	if (!strResult) {
  		return false;
  	}

  	var objResult = JSON.parse(strResult);
  	var objFunc = g_ox_sdk_request_map[objResult.request_id];
  	if (objResult.action_type == "init_sdk") {
  		objFunc = g_ox_sdk_init_callback_func;
  	}

  	var strScript = "return ((typeof " + objFunc + ") == \"function\" || (typeof " +
  		objFunc + ") == \"object\") ";
  	strScript += " ? true : false";
  	var isfunc = new Function(strScript);
  	if (!isfunc()) {
  		return false;
  	}
  	objFunc.call(this, objResult.result);
  }

  function getRand(n) {
  	var chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K',
  		'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
  	];
  	var res = "";
  	for (var i = 0; i < n; i++) {
  		var id = Math.ceil(Math.random() * 35);
  		res += chars[id];
  	}
  	return res;
  }
